{
    Copyright (C) 2011  Ralph Kokott, Niklas Kopyciok

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, math, ComCtrls, Buttons, jpeg;

type  TTree = array of Record
        Belegt: boolean;
        Size:integer;
      end;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    ListBox1: TListBox;
    Timer1: TTimer;
    ListBox2: TListBox;
    Button3: TButton;
    ListBox3: TListBox;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Panel1: TPanel;
    Timer2: TTimer;
    Panel2: TPanel;
    ZielComboBox: TComboBox;
    StatusBar1: TStatusBar;
    AnimBitBtn: TBitBtn;
    Image2: TImage;
    CPULabel: TLabel;
    DauerLabel: TLabel;
    AnimNextBtn: TButton;
    ProgressBar1: TProgressBar;
    procedure Respring();
    procedure BW(Anzahl:integer;links,mitte,rechts:Char);
    procedure Button2Click(Sender: TObject);
    procedure Zeichne(turm,id,pos:integer);
    procedure Timer1Timer(Sender: TObject);
    procedure OnCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function GetHigh(getarray:Array of Integer):integer;
    function GetHigh2(getarray:Array of Integer):integer;
    function GetHighA:integer;
    function GetHighB:integer;
    function GetHighC:integer;
    procedure Edit1Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure AnimBitBtnClick(Sender: TObject);
    function GetCPUSpeed: real;
    procedure AnimNextBtnClick(Sender: TObject);


  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1:  TForm1;
  i,ia:   integer;
  Aarray: Array of char;
  Barray: Array of char;
  ATurm:  Array[1..30] of Integer;
  BTurm:  Array[1..30] of Integer;
  CTurm:  Array[1..30] of Integer;
  runde:  integer;
  zeit:   integer;
  count:  integer;
  anim:   integer;
  Farbe:array[1..8] of TColor = (clRed,clBlue,clYellow,clGreen,clMaroon,clNavy,clSilver,clLime);
  CPU:    integer;
  zuege:  integer;

implementation

{$R *.dfm}





function TForm1.GetHigh(getarray:Array of Integer):integer;
var j:integer;
begin
   j:=0;
   if (getarray[1]>0) and (getarray[1]<10000) then j:=1;
   if (getarray[2]>0) and (getarray[2]<10000) then j:=2;
   if (getarray[3]>0) and (getarray[3]<10000) then j:=3;
   if (getarray[4]>0) and (getarray[4]<10000) then j:=4;
   result:=j+1;
end;

function TForm1.GetHigh2(getarray:Array of Integer):integer;
var j:integer;
begin
   j:=0;
   if (getarray[1]>0) and (getarray[1]<10000) then j:=j+1;
   if (getarray[2]>0) and (getarray[2]<10000) then j:=j+1;
   if (getarray[3]>0) and (getarray[3]<10000) then j:=j+1;
   if (getarray[4]>0) and (getarray[4]<10000) then j:=j+1;
   result:=j;
end;


procedure TForm1.Zeichne(turm,id,pos:integer);
begin
if StrToInt(Edit1.Text)>9 then begin
  if id>8 then Image1.Canvas.Brush.Color:=Farbe[id-8] else
                Image1.Canvas.Brush.Color:=Farbe[id];
  Image1.Canvas.Rectangle(40+(turm-1)*140+(50 div StrToInt(Edit1.Text)*(id-1)),
                        230-(pos-1)*180 div StrToInt(Edit1.Text),
                        140+(turm-1)*140-(50 div StrToInt(Edit1.Text)*(id-1)),
                        230-(pos)*180 div StrToInt(Edit1.Text));
                        end
else
begin
  Image1.Canvas.Brush.Color:=Farbe[id];
  Image1.Canvas.Rectangle(40+(turm-1)*140+(50 div StrToInt(Edit1.Text)*(id-1)),
                        210-(pos-1)*20,
                        140+(turm-1)*140-(50 div StrToInt(Edit1.Text)*(id-1)),
                        230-(pos-1)*20);
end;

  Image1.Canvas.Brush.Color:=clwhite;
end;


procedure TForm1.Respring();
begin
  Image1.Canvas.Brush.Color:=clwhite;
  Image1.Canvas.Rectangle(-1,-1,clientwidth+1,clientheight+1);
  Image1.Canvas.TextOut(70,240,'Stapel 1');
  Image1.Canvas.MoveTo(40,230);               // waagerechte Linie
  Image1.Canvas.LineTo(140,230);
  Image1.Canvas.MoveTo(90,230);               // senkrechte Linie
  if (StrToIntDef(Edit1.Text,0)<5) then Image1.Canvas.LineTo(90,130) else
  Image1.Canvas.LineTo(90,50);

  Image1.Canvas.TextOut(210,240,'Stapel 2');
  Image1.Canvas.MoveTo(180,230);
  Image1.Canvas.LineTo(280,230);
  Image1.Canvas.MoveTo(230,230);
  if (StrToIntDef(Edit1.Text,0)<5) then Image1.Canvas.LineTo(230,130) else
  Image1.Canvas.LineTo(230,50);

  Image1.Canvas.TextOut(350,240,'Stapel 3');
  Image1.Canvas.MoveTo(320,230);
  Image1.Canvas.LineTo(420,230);
  Image1.Canvas.MoveTo(370,230);
  if (StrToIntDef(Edit1.Text,0)<5) then Image1.Canvas.LineTo(370,130) else
  Image1.Canvas.LineTo(370,50);

end;




procedure TForm1.BW(Anzahl:integer;links,mitte,rechts:Char);
begin


  //Statusbar1.Panels[0].Text:=' Berechne Zug '+IntToStr(i)+' von '+Label2.Caption;
  if Anzahl = 0 then showmessage('Ungltige Eingabe') else  begin
  if Anzahl = 1 then  begin
    ProgressBar1.Position:=ProgressBar1.Position+1;
    Application.ProcessMessages;
    count:=count+1;
    Form1.ListBox1.Items.Add(IntToStr(count)+' - '+links+'->'+mitte);
    ia:=ia+1;
    Setlength(Aarray,ia);    SetLength(Barray,ia);
    Aarray[ia-1]:=links;    Barray[ia-1]:=mitte;
  end
  else
    begin
      BW(Anzahl-1,links,rechts,mitte);
      BW(1,links,mitte,rechts);
      BW(Anzahl-1,rechts,mitte,links);
    end;
  end;
end;


procedure TForm1.Button2Click(Sender: TObject);
var j:integer;
begin
  SetPriorityClass(GetCurrentProcess, NORMAL_PRIORITY_CLASS);
  AnimNextBtn.Visible:=true;
  //Application.ProcessMessages;
  runde:=1;
  anim:=1;
if ZielComboBox.ItemIndex=-1 then showmessage('Bitte ein Ziel auswhlen')
else begin
  ProgressBar1.Visible:=true;
  ProgressBar1.Max:=zuege;
  Statusbar1.Panels[0].Text:=' Berechnung luft...';
  Application.ProcessMessages;
  Aarray:=Nil;
  Barray:=Nil;
  FillChar(BTurm,SizeOf(BTurm),0);
  FillChar(CTurm,SizeOf(CTurm),0);
  ListBox1.Clear;
  ia:=1;
  count:=0;
  zeit:=GetTickCount();
  if ZielComboBox.ItemIndex=1 then  BW(StrToIntDef(Edit1.Text,0),'l','r','m');
  if ZielComboBox.ItemIndex=0 then  BW(StrToIntDef(Edit1.Text,0),'l','m','r');
  zeit:=GetTickCount()-zeit;
  if zeit=0 then
  Statusbar1.Panels[0].Text:=' Berechnungsdauer: unter 1 Millisekunde'
  else begin if zeit=1 then
  Statusbar1.Panels[0].Text:=' Berechnungsdauer: 1 Millisekunde'
  else
  Statusbar1.Panels[0].Text:=' Berechnungsdauer: '+IntToStr(zeit)+' Millisekunden';
  end;

end; // ziel ausgewhlt ende

i:=1;
while i<StrToIntDef(Edit1.Text,0)+1 do begin
  ATurm[i]:=i;
  i:=i+1;
end;

Respring;

j:=1;
while j<StrToIntDef(Edit1.Text,0)+1 do begin
  if ATurm[j]<>0 then Zeichne(1,ATurm[j],j);
  if BTurm[j]<>0 then Zeichne(2,BTurm[j],j);
  if CTurm[j]<>0 then Zeichne(3,CTurm[j],j);
  j:=j+1;
end;
ProgressBar1.Visible:=false;
ProgressBar1.Position:=0;
end;



procedure TForm1.Timer1Timer(Sender: TObject);
var j,r:integer;
begin

anim:=2;
if runde<Length(Aarray) then begin

case Aarray[runde] of
'l': begin
    if BArray[runde]='l' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

    if BArray[runde]='m' then begin
                              //if GetHighB)=0 then BTurm[1]:=ATurm[GetHighA)] else
                                BTurm[GetHighB+1]:=ATurm[GetHighA];
                                ATurm[GetHighA]:=0;
    end;
    if BArray[runde]='r' then begin
                              //if GetHigh(CTurm)=0 then CTurm[1]:=ATurm[GetHighA] else
                                CTurm[GetHighC+1]:=ATurm[GetHighA];
                                ATurm[GetHighA]:=0;
      end;
     end;
'm': begin
    if BArray[runde]='l' then begin
                               //if GetHigh(ATurm)=0 then ATurm[1]:=BTurm[GetHighB)] else
                                ATurm[GetHighA+1]:=BTurm[GetHighB];
                                BTurm[GetHighB]:=0;
    end;
    if BArray[runde]='m' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

    if BArray[runde]='r' then begin
                               //if GetHigh(CTurm)-1=0 then CTurm[1]:=BTurm[GetHigh(BTurm)] else
                                CTurm[GetHighC+1]:=BTurm[GetHighB];
                                BTurm[GetHighB]:=0;
    end;

end;
'r': begin
    if BArray[runde]='l' then begin
                               //if GetHigh(ATurm)=0 then ATurm[1]:=CTurm[GetHighB] else
                                ATurm[GetHighA+1]:=CTurm[GetHighC];
                                CTurm[GetHighC]:=0;
    end;
    if BArray[runde]='m' then begin
                               //if GetHigh(BTurm)=0 then ATurm[1]:=CTurm[GetHighB] else
                                BTurm[GetHighB+1]:=CTurm[GetHighC];
                                CTurm[GetHighC]:=0;
    end;
    if BArray[runde]='r' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

  end;

end;

if AnimBitBtn.Kind<>bkHelp then begin
  AnimBitBtn.Kind:=bkHelp;
  AnimBitBtn.Caption:='Pause';
 end;

Statusbar1.Panels[1].Text:='Zug '+IntToStr(runde)+' von '+FloatToStr(Power(2,StrToFloat(Edit1.Text))-1);
if runde = Trunc(Power(2,StrToFloat(Edit1.Text))-1) then begin
  Timer1.Enabled:=false;
  AnimBitBtn.Kind:=bkIgnore;
  AnimBitBtn.Caption:='Animation';
  anim:=1;
 end;
runde:=runde+1;
Respring;

//Debug3
r:=1;
Listbox3.Clear;
Listbox3.Items.Add('ATurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(ATurm[r]));    r:=r+1; end; r:=1;
Listbox3.Items.Add('BTurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(BTurm[r]));    r:=r+1; end; r:=1;
Listbox3.Items.Add('CTurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(CTurm[r]));    r:=r+1; end;

// Aktuelle Posis zeichnen
j:=1;
while j<StrToIntDef(Edit1.Text,0)+1 do begin
if ATurm[j]<>0 then Zeichne(1,ATurm[j],j);
if BTurm[j]<>0 then Zeichne(2,BTurm[j],j);
if CTurm[j]<>0 then Zeichne(3,CTurm[j],j);
j:=j+1;
end;
end;
end;

procedure TForm1.OnCreate(Sender: TObject);
begin
  Canvas.TextOut(0,0,'RK Systems proudly present...');                                 // todo
  anim:=0;
  runde:=0;
  CPU:=Trunc(GetCPUSpeed);
  CPULabel.Caption:='CPU: '+IntToStr(CPU)+' Mhz';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if Timer1.Enabled=true then Timer1.Enabled:=false else
   Timer1.Enabled:=true;
Listbox2.Items.Add('A '+IntToStr(GetHighA));
Listbox2.Items.Add('B '+IntToStr(GetHighB));
Listbox2.Items.Add('C '+IntToStr(GetHighC));
end;

function TForm1.GetHighA:integer;
var j,k:integer;
begin
   j:=0;
   k:=1;
   while k<StrToIntDef(Edit1.Text,0)+1 do begin
   if (ATurm[k]>0) and (ATurm[k]<10000) then j:=j+1;
   k:=k+1;
   end;
   result:=j;
end;

function TForm1.GetHighB:integer;
var j,k:integer;
begin
   j:=0;
   k:=1;
   while k<StrToIntDef(Edit1.Text,0)+1 do begin
   if (BTurm[k]>0) and (BTurm[k]<10000) then j:=j+1;
   k:=k+1;
   end;
   result:=j;
end;

function TForm1.GetHighC:integer;
var j,k:integer;
begin
   j:=0;
   k:=1;
   while k<StrToIntDef(Edit1.Text,0)+1 do begin
   if (CTurm[k]>0) and (CTurm[k]<10000) then j:=j+1;
   k:=k+1;
   end;
   result:=j;
end;

procedure TForm1.Edit1Change(Sender: TObject);
const berechnungsk=0.00000007754774789320;
var scheiben  :integer;
begin
  scheiben := StrToIntDef(Edit1.Text,0);
  anim:=0;
  if scheiben = 0 then exit;
  if scheiben > 31 then
    begin
      showmessage('Berechnung berschreitet zugewiesen Speicher - Berechnungsdauer von mehreren Tagen');
      exit;
    end;

  if scheiben>0 then
    begin
      zuege:= trunc(Power(2,StrToFloat(Edit1.Text))-1);
      Label2.Caption:='Zge: '+IntToStr(zuege);
      DauerLabel.Caption:='Geschtzte Dauer: '+FloattoStr(round(zuege*berechnungsk*CPU *1000) / 1000)+' Sek';

    end;
end;



procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 if Trackbar1.Position=1 then Timer1.Interval:=2000;
 if Trackbar1.Position=2 then Timer1.Interval:=1100;
 if Trackbar1.Position=3 then Timer1.Interval:=500;
 if Trackbar1.Position=4 then Timer1.Interval:=165;
 if Trackbar1.Position=5 then Timer1.Interval:=80;
end;



procedure TForm1.Timer2Timer(Sender: TObject);
begin
 Panel1.Visible:=true;
 Panel2.Visible:=true;
 Timer2.Enabled:=false;
 Image1.Visible:=true;
end;


procedure TForm1.AnimBitBtnClick(Sender: TObject);
var i,j:integer;
begin
if anim=0 then exit;

if anim=1 then begin
  i:=1;
  while i<StrToIntDef(Edit1.Text,0)+1 do begin
    ATurm[i]:=i;
    i:=i+1;
  end;
  Statusbar1.Panels[1].Text:='';

  // Animation
    runde:=1;
  Timer1.Enabled:=true;

  Image1.Canvas.Brush.Color:=clblack;                 // 40-140 Grundebene     // 280 = Y Startkoordinate
  Image1.Canvas.Pen.Color:=clblack;

  j:=1;
  while j<5 do begin
    BTurm[j]:=0;
    CTurm[j]:=0;
    j:=j+1;
  end;

  Respring;

  j:=1;
  while j<StrToIntDef(Edit1.Text,0)+1 do begin
   if ATurm[j]<>0 then Zeichne(1,ATurm[j],j);
   if BTurm[j]<>0 then Zeichne(2,BTurm[j],j);
   if CTurm[j]<>0 then Zeichne(3,CTurm[j],j);
    j:=j+1;
  end;
 end; // if anim=1

if anim=2 then begin
  Timer1.Interval:=Timer1.Interval+1;
  Timer1.Enabled:=false;
  anim:=3;
  exit;
end;

if anim=3 then begin
  Timer1.Enabled:=true;
  anim:=2;
  exit;
end;

end;


function TForm1.GetCPUSpeed: real;

const TimeOfDelay = 100;                                  // Zeit ist variabel (??)
//var TimerHigh, TimerLow: DWORD;
var TimerLow:DWORD;

begin
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(7);
  asm                                // Assembler-Sprache
   dw 310Fh
   mov TimerLow, eax               // TimerLow in Speicher A
  //   mov TimerHigh, edx              // TimerHigh in Speicher D
  end;

  Sleep(TimeOfDelay);
  asm
    dw 310Fh
    sub eax, TimerLow        // subtrahiert
  //    sbb edx, TimerHigh         // SBB : Speicher D - TimerHigh(+Carry-Flag)
    mov TimerLow, eax          // TimerLow := eax		- Speicher A in TimerLow
  //    mov TimerHigh, edx         // TimerHigh := eadx  - Speicher D in TimerHigh
  end;
                              // TimerHigh kann auskommentiert werden -> keine Verwendung
  // wird TimerHigh nicht benutzt, kann die Messung ungenau werden.. eigentlich TLow-THigh/(1000*(Sleep2-Sleep1)
  Result := trunc(TimerLow / (1000.0 * TimeOfDelay));
end;


procedure TForm1.AnimNextBtnClick(Sender: TObject);
var j,r:integer;
begin
if runde<Length(Aarray) then begin

case Aarray[runde] of
'l': begin
    if BArray[runde]='l' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

    if BArray[runde]='m' then begin
                              //if GetHighB)=0 then BTurm[1]:=ATurm[GetHighA)] else
                                BTurm[GetHighB+1]:=ATurm[GetHighA];
                                ATurm[GetHighA]:=0;
    end;
    if BArray[runde]='r' then begin
                              //if GetHigh(CTurm)=0 then CTurm[1]:=ATurm[GetHighA] else
                                CTurm[GetHighC+1]:=ATurm[GetHighA];
                                ATurm[GetHighA]:=0;
      end;
     end;
'm': begin
    if BArray[runde]='l' then begin
                               //if GetHigh(ATurm)=0 then ATurm[1]:=BTurm[GetHighB)] else
                                ATurm[GetHighA+1]:=BTurm[GetHighB];
                                BTurm[GetHighB]:=0;
    end;
    if BArray[runde]='m' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

    if BArray[runde]='r' then begin
                               //if GetHigh(CTurm)-1=0 then CTurm[1]:=BTurm[GetHigh(BTurm)] else
                                CTurm[GetHighC+1]:=BTurm[GetHighB];
                                BTurm[GetHighB]:=0;
    end;

end;
'r': begin
    if BArray[runde]='l' then begin
                               //if GetHigh(ATurm)=0 then ATurm[1]:=CTurm[GetHighB] else
                                ATurm[GetHighA+1]:=CTurm[GetHighC];
                                CTurm[GetHighC]:=0;
    end;
    if BArray[runde]='m' then begin
                               //if GetHigh(BTurm)=0 then ATurm[1]:=CTurm[GetHighB] else
                                BTurm[GetHighB+1]:=CTurm[GetHighC];
                                CTurm[GetHighC]:=0;
    end;
    if BArray[runde]='r' then showmessage('Kernel Error 0x001337CRN'); // nicht mglich

  end;

end;

if AnimBitBtn.Kind<>bkHelp then begin
  AnimBitBtn.Kind:=bkHelp;
  AnimBitBtn.Caption:='Pause';
 end;

Statusbar1.Panels[1].Text:='Zug '+IntToStr(runde)+' von '+FloatToStr(Power(2,StrToFloat(Edit1.Text))-1);
if runde = Trunc(Power(2,StrToFloat(Edit1.Text))-1) then begin
  Timer1.Enabled:=false;
  AnimBitBtn.Kind:=bkIgnore;
  AnimBitBtn.Caption:='Animation';
  anim:=1;
 end;
runde:=runde+1;
Respring;

//Debug3
r:=1;
Listbox3.Clear;
Listbox3.Items.Add('ATurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(ATurm[r]));    r:=r+1; end; r:=1;
Listbox3.Items.Add('BTurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(BTurm[r]));    r:=r+1; end; r:=1;
Listbox3.Items.Add('CTurm');
while r<5 do begin
Listbox3.Items.Add(IntToStr(r)+' '+IntToStr(CTurm[r]));    r:=r+1; end;

// Aktuelle Posis zeichnen
j:=1;
while j<StrToIntDef(Edit1.Text,0)+1 do begin
if ATurm[j]<>0 then Zeichne(1,ATurm[j],j);
if BTurm[j]<>0 then Zeichne(2,BTurm[j],j);
if CTurm[j]<>0 then Zeichne(3,CTurm[j],j);
j:=j+1;
end;
end;

end;

end.

